#define BLYNK_PRINT Serial
#include <ESP8266WiFi.h>
#include <BlynkSimpleEsp8266.h>
#include <TimeLib.h>
#include <WidgetRTC.h>

BlynkTimer timer;
WidgetRTC rtc;

const int RELAY_PIN = D9;
const int RELAY_PIN1 = D8;

int pinValue;
int pinModeValue1 = 0;

int Shour;
int Smin;
int Ss;
int Ehour;
int Emin;
int Es;

char ssid[] = "Network name";
char pass[] = "password";
char auth[] = "Blynk token";

/*************************************************************************************************************************************************************************************/

BLYNK_CONNECTED()
{
  rtc.begin();
}

// Digital clock display of the time
void clockDisplay()
{
  // You can call hour(), minute(), ... at any time
  // Please see Time library examples for details
  if (pinModeValue1 == 0) {
    String currentTime = String(hour()) + ":" + minute() + ":" + second();
    String currentDate = String(day()) + " " + month() + " " + year();
    int h = hour();
    int m = minute();
    Serial.print("Current time: ");
    Serial.print(currentTime);
    Serial.print(" ");
    Serial.print(currentDate);
    Serial.println();

    //works only if shour is less than end hour and for all days (make two if blocks comparing start and end hours and wrap code below in it), if want to do different days, add function(top of programme) to see which day is it and then compare,
    if (h > Shour && h < Ehour) {
      digitalWrite(RELAY_PIN, LOW);
      digitalWrite(RELAY_PIN1, LOW);
    }
    if (h < Shour && h < Ehour) {
      digitalWrite(RELAY_PIN, HIGH);
      digitalWrite(RELAY_PIN1, HIGH);
      digitalWrite(RELAY_PIN1, HIGH);
    }
    if (h > Shour && h > Ehour) {
      digitalWrite(RELAY_PIN, HIGH);
      digitalWrite(RELAY_PIN1, HIGH);
      digitalWrite(RELAY_PIN1, HIGH);
    }
    if (h == Ehour && h == Shour ) {
      if (m >= Emin || m < Smin) {
        digitalWrite(RELAY_PIN, HIGH);
        digitalWrite(RELAY_PIN1, HIGH);
      }
      if (m < Emin && m >= Smin) {
        digitalWrite(RELAY_PIN, LOW);
        digitalWrite(RELAY_PIN1, LOW);
      }
    }
    if (h == Ehour && h > Shour ) {
      if (m >= Emin) {
        digitalWrite(RELAY_PIN, HIGH);
        digitalWrite(RELAY_PIN1, HIGH);
      }
      if (m < Emin) {
        digitalWrite(RELAY_PIN, LOW);
        digitalWrite(RELAY_PIN1, LOW);
      }
    }
    if (h < Ehour && h == Shour ) {
      if ( m < Smin) {
        digitalWrite(RELAY_PIN, HIGH);
        digitalWrite(RELAY_PIN1, HIGH);
      }
      if ( m >= Smin) {
        digitalWrite(RELAY_PIN, LOW);
        digitalWrite(RELAY_PIN1, LOW);
      }
    }
  }
}


BLYNK_WRITE(V1) {

  TimeInputParam t(param);

  // Process start time

  if (t.hasStartTime())
  {
    Serial.println(String("Start: ") +
                   t.getStartHour() + ":" +
                   t.getStartMinute() + ":" +
                   t.getStartSecond());
    delay(500);
    Shour = t.getStartHour();
    Blynk.virtualWrite(V7, Shour);
    Smin = t.getStartMinute();
    Blynk.virtualWrite(V8, Smin);
    Ss =  t.getStartSecond();
    Blynk.virtualWrite(V9, Ss);
    delay(1000);
  }
  else
  {
    // Do nothing
  }

  // Process stop time

  if (t.hasStopTime())
  {
    Serial.println(String("Stop: ") +
                   t.getStopHour() + ":" +
                   t.getStopMinute() + ":" +
                   t.getStopSecond());
    delay(500);
    Ehour = t.getStopHour();
    Blynk.virtualWrite(V10, Ehour);
    Emin = t.getStopMinute();
    Blynk.virtualWrite(V11, Emin);
    Es = t.getStopSecond();
    Blynk.virtualWrite(V12, Es);
  }
  else
  {
    // Do nothing: no stop time was set
  }

  // Process timezone
  // Timezone is already added to start/stop time

  Serial.println(String("Time zone: ") + t.getTZ());

  // Get timezone offset (in seconds)
  Serial.println(String("Time zone offset: ") + t.getTZ_Offset());

  // Process weekdays (1. Mon, 2. Tue, 3. Wed, ...)

  for (int i = 1; i <= 7; i++) {
    if (t.isWeekdaySelected(i)) {
      Serial.println(String("Day ") + i + " is selected");
    }
  }
  Serial.println();
}

BLYNK_WRITE(V2)
{
  int pinValue = param.asInt(); 
  if ( pinValue = 1) {
    if (int(pinModeValue1)  % 2 == 0) {
      //
    }
    else {
      digitalWrite(RELAY_PIN, LOW);
      digitalWrite(RELAY_PIN1, LOW);
    }
  }
}

BLYNK_WRITE(V3)
{
  int pinValue = param.asInt(); 
  if ( pinValue = 1) {
    if (int(pinModeValue1)  % 2 == 0) {
      //
    }
    else {
      digitalWrite(RELAY_PIN, HIGH);
      digitalWrite(RELAY_PIN1, HIGH);
    }
  }
}

BLYNK_WRITE(V0) {
  switch (param.asInt())
  {
    case 1: { // Item 1
        pinModeValue1 = 0;
        break;
      }
    case 2: { // Item 2
        pinModeValue1 = 1;
        break;
      }
    
    }
}


void setup()
{
  // Debug console
  Serial.begin(9600);
  Blynk.begin(auth, ssid, pass);

  pinMode(RELAY_PIN, OUTPUT);
  digitalWrite(RELAY_PIN, HIGH);
  pinMode(RELAY_PIN1, OUTPUT);
  digitalWrite(RELAY_PIN1, HIGH);

  Serial.println("Start sync");
  delay(200);
  Blynk.syncVirtual(V0);
  delay(200);
  Blynk.syncVirtual(V1);
  delay(200);
  
  setSyncInterval(20 * 60); // Sync interval in seconds (10 minutes)
  // Display digital clock every 10 seconds
  timer.setInterval(10000L, clockDisplay);
}

void loop()
{
  Blynk.run();
  timer.run();
}
